use szun::*;

fn main() {
    let mut int = Integer::new().with(512);
    let boo = Boolean::new().with(false);
    let mut var = Var::new();
    var.set(&int);

    let int2 :Integer = var.get();
    println!("{}", int2.get::<i32>());

    int.set(1024);
    let mut lst = List::<Var>::new();
    lst.push(&int);
    lst.push(&boo);

    int.set(20); lst.push(&int);

    for i in 0..lst.len() {
        if let Ok(int) = lst.get(i).try_get::<Integer>() {
            println!("{}", int.get::<i32>());
        }
    }

    let mut arr = Array::<2, Var>::new();
    int.set(30); arr.set(0, &int);
    arr.set(1, &boo);

    for i in 0..arr.len() {
        if let Ok(int) = arr.get(i).try_get::<Integer>() {
            println!("{}", int.get::<i32>());
        }
    }
}
