mod reference; pub use reference::Ref;
mod error; pub use error::SzunError;

pub trait SzunType : Clone {
    fn type_id() -> usize;
    fn to_ref(self) -> Ref;

    fn compatible<T: SzunType>(&self, refr:&T) -> bool;

    fn __to_ref(&self) -> Ref;
    fn __from_ref(refr:Ref) -> Self;
}
